import java.io.StringReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
/**
 * User/system view adapted email system.
 */
public class USViewMail extends AbstractEmail {
  /**
   * Returns true when the given sender sent the message.
   */
  public boolean systemView() {
    String line, className = new String();
    // Create exception for tracing sender
    Exception e = new Exception();
    StringWriter str = new StringWriter();
    PrintWriter pr = new PrintWriter(str);
    try {
      // Retrieve stack image
      e.printStackTrace(pr);
      pr.flush();
      pr.close();
      // Read string
      BufferedReader br = new BufferedReader(
        new StringReader(str.toString()));
      // Skip 3 lines and read the 4th
      br.readLine(); br.readLine(); br.readLine();
      line = br.readLine();
      if (line.indexOf('(') != -1)
        line = line.substring(line.indexOf("at ")+3, line.indexOf('('));
      else
        line = line.substring(line.indexOf("at ")+3);
      className = line.substring(0, line.lastIndexOf('.')+1);
    } catch (IOException ioe) {
      ioe.printStackTrace();
    }
    return className.equals("System");
    
  }
  /**
   * Only System can set route now
   */
  public void setRoute(String route) {
    if (systemView())
      super.setRoute(route);
    else
      System.err.println("setRoute not allowed");
  }
  /**
   * Only System can approve now
   */
  public void approve() {
    if (systemView())
      super.approve();
    else
      System.err.println("approve not allowed");
  }
  /**
   * Only System can deliver now
   */
  public void deliver() {
    if (systemView())
      super.deliver();
    else
      System.err.println("deliver not allowed");
  }
  /**
   * Returns true when the given sender sent the message.
   */
  public boolean userView() {
    String line, className = new String();
    // Create exception for tracing sender
    Exception e = new Exception();
    StringWriter str = new StringWriter();
    PrintWriter pr = new PrintWriter(str);
    try {
      // Retrieve stack image
      e.printStackTrace(pr);
      pr.flush();
      pr.close();
      // Read string
      BufferedReader br = new BufferedReader(
        new StringReader(str.toString()));
      // Skip 3 lines and read the 4th
      br.readLine(); br.readLine(); br.readLine();
      line = br.readLine();
      if (line.indexOf('(') != -1)
        line = line.substring(line.indexOf("at ")+3, line.indexOf('('));
      else
        line = line.substring(line.indexOf("at ")+3);
      className = line.substring(0, line.lastIndexOf('.')+1);
    } catch (IOException ioe) {
      ioe.printStackTrace();
    }
    return className.equals("User");
    
  }
  /**
   * Only User can set the originator now
   */
  public void setOriginator(String originator) {
    if (userView())
      super.setOriginator(originator);
    else
      System.err.println("setOriginator not allowed");
  }
  /**
   * Only User can set the receiver now
   */
  public void setReceiver(String receiver) {
    if (userView())
      super.setReceiver(receiver);
    else
      System.err.println("setReceiver not allowed");
  }
  /**
   * Only User can set content now
   */
  public void setContent(String content) {
    if (userView())
      super.setContent(content);
    else
      System.err.println("setContent not allowed");
  }
  /**
   * Only User can send now
   */
  public void send() {
    if (userView())
      super.send();
    else
      System.err.println("send not allowed");
  }
  /**
   * Only User can reply now
   */
  public void reply() {
    if (userView())
      super.reply();
    else
      System.err.println("reply not allowed");
  }
  /**
   * Only User can read content now
   */
  public String getContent() {
    if (userView())
      return super.getContent();
    else
      System.err.println("getContent not allowed");
    return null;
  }
}